C***********************************************************************
 
!  This component has been assigned Type Number 205. If that number conflicts with 
!  another user Type number, you will need to change it and recompile the appropriate
!  dll.

      SUBROUTINE TYPE205(TIME,XIN,OUT,T,DTDT,PAR,INFO,ICNTRL,*)

!DEC$ATTRIBUTES DLLEXPORT :: TYPE205
 
  
  
C ----------------------------------------------------------------------
C
C       TYPE 205 : EVAPORATIVE HUMIDIFIER MODEL
C
C       This model is developed  based on the model by J. Chi.
C
C***********************************************************************

      INTEGER INFO
      DOUBLE PRECISION XIN,OUT
      REAL    PAR
C     INTEGER IOSTAT
      DIMENSION  XIN(3),OUT(3),PAR(1),INFO(15)
C     DIMENSION  IOSTAT(3)
  
C*    COMMON  /PROPER/RHOA,RHOW,CPA,CPW

C  The CPA properties @300 K, 1 atm
C  The units are:
C      CPA - kJ/kg-K
      DATA  CPA /1.007/

      DATA CPS,HFG/1.8723,2501./
      DATA RMOL,TREF,PATM/.62198,-20.0,101.325/

!    Set the version information for TRNSYS
      IF (INFO(7).EQ.-2) THEN
	  INFO(12) = 15
	  RETURN 1
	ENDIF

  
      TAI=  XIN(1)
      WAI=  XIN(2)
      FLWAI=XIN(3)
  
      HA=PAR(1)
  
      HAI=(CPS*(TAI-TREF)+HFG)*WAI/(1.0+WAI)+CPA*(TAI-TREF)
  
C       Convert inlet enthalpy to Btu/lbm for the purpose of
C       calculating the wet bulb temperature.
  
      HAI=HAI/2.326
      TWTB=30.9185+ALOG(HAI)*(-39.682+ALOG(HAI)*(20.5841-
     & 1.758*ALOG(HAI)))
      TWTB=(TWTB-32.)*5./9.
      WAOS=RMOL*PSATS(TWTB)/(PATM-PSATS(TWTB))
      WAO=WAI+(WAOS-WAI)*(1-EXP(-HA/(CPA*FLWAI)))
      TAO=TAI-(WAO-WAI)*HFG/CPA
      FLWAO=FLWAI*(1.0+WAO)/(1.0+WAI)
  
      OUT(1)=WAO
      OUT(2)=TAO
      OUT(3)=FLWAO
  
C     IOSTAT(1)=1
C     IOSTAT(2)=1
C     IOSTAT(3)=1

      RETURN 1
      END
  
C***********************************************************************

        FUNCTION PSATS(TC)

C ----------------------------------------------------------------------
C
C  Saturation pressure of steam (KPA) as a function of temperature (C)
C
C***********************************************************************

        DATA A0,A1,A2,A3/10.4592,-0.404897E-2,-0.417520E-4,0.368510E-6/
        DATA A4,A5,A6/-0.101520E-8,0.865310E-12,0.903668E-15/
        DATA A7,A8,A9/-0.199690E-17,0.779287E-21,0.191482E-24/
        DATA A10,A11,TCONV,PCONV/-3968.06,39.5735,273.15,1000./

        T=TC+TCONV
        PLOG=A0+T*(A1+T*(A2+T*(A3+T*(A4+T*(A5+T*(A6+T*(A7+T*(A8+T*A9
     &       )))))))) + A10/(T-A11)
        PSATS=PCONV*EXP(PLOG)

        RETURN
        END